// OHMDlg.h : wb_[ t@C
//

#if !defined(AFX_OHMDLG_H__4F17837B_E413_409E_8E59_83130DE52BE0__INCLUDED_)
#define AFX_OHMDLG_H__4F17837B_E413_409E_8E59_83130DE52BE0__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#pragma warning (disable:4786) 

#include <vector>
#include <string>

class COHM{
public:
	double dA;
	double dB;
	double dC;
};

struct CData{
	std::vector<std::string> m_aryDate;
	std::vector<double>      m_aryDate_double;

	// input variables for foward model
	std::vector<double> m_aryRn;				// air temperature (degree C)
};

/////////////////////////////////////////////////////////////////////////////
// COHMDlg _CAO

class COHMDlg : public CDialog
{
// \z
public:
	COHMDlg(CWnd* pParent = NULL);	// W̃RXgN^

// _CAO f[^
	//{{AFX_DATA(COHMDlg)
	enum { IDD = IDD_OHM_DIALOG };
	CString	m_strInFile;
	CString	m_strInPRM;
	CString	m_strOutDir;
	double	m_dFracVegetation;
	double	m_dFracTrees;
	double	m_dFracGrass;
	double	m_dFracCropland;
	double	m_dFracPavement;
	double	m_dFracBuilding;
	double	m_dFracBareSoil;
	double	m_dFracWater;
	BOOL	m_bUseDetailedVegetation;
	int		m_iBootstrapNum;
	int		m_iRunPerDayRadio;
	//}}AFX_DATA

	// ClassWizard ͉z֐̃I[o[Ch𐶐܂B
	//{{AFX_VIRTUAL(COHMDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV ̃T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:
	HICON m_hIcon;
	CString m_strInTitle;

	static const double c_dError;
	static const int MAX_NUM;

	std::vector<COHM> m_aryVegetation;
	std::vector<COHM> m_aryTrees;
	std::vector<COHM> m_aryGrass;
	std::vector<COHM> m_aryCropland;
	std::vector<COHM> m_aryPaved;
	std::vector<COHM> m_aryBuilding;
	std::vector<COHM> m_aryBairsoil;
	std::vector<COHM> m_aryWater;

	std::vector<double> m_aryG_ave;
	std::vector<double> m_aryG_stdev;
	std::vector<double> m_aryG_ave_daily;
	std::vector<double> m_aryG_stdev_daily;
	std::vector<double> m_aryG_ave_annual;
	std::vector<double> m_aryG_stdev_annual;

	void OHM(CData& data);
	void calculate_G_OHM(COHM& cPRM, const std::vector<double>& aryRn, std::vector<double>& aryG);
	void average_stdev(const std::vector< std::vector<double> >& aryInput, std::vector<double>& aryAverage, std::vector<double>& aryStdev);

	bool input_csv_file(const CString& strFile, CData& data);
	int  read_setting_file(const CString& strInSettingFile);
	bool output_file(CData& data);
	bool SetParameterFromFile(const CString& strFilePass);
	bool write_setting_file(const CString& strFilePass);
	void DeleteHeadSpace(std::string &buf);
	void DeleteSpace(std::string &buf);

	// ꂽbZ[W }bv֐
	//{{AFX_MSG(COHMDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnKillfocus();
	afx_msg void OnBtnInFile();
	afx_msg void OnBtnInPrm();
	afx_msg void OnBtnOutDir();
	afx_msg void OnCheckVegetation();
	afx_msg void OnBtnOHM();
	afx_msg void OnBtnLoadSetting();
	afx_msg void OnBtnSaveSetting();
	afx_msg void OnRadio1();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ ͑Os̒Oɒǉ̐錾}܂B

#endif // !defined(AFX_OHMDLG_H__4F17837B_E413_409E_8E59_83130DE52BE0__INCLUDED_)
